// Polimorfism
#include <iostream>
using namespace std;
// Functii virtuale

class Fiinta {
public:
    virtual void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Om : public Fiinta {
public:
    void SeHraneste() const // Overriding
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Caine : public Animal {
public:

};

/* Legare Dinamica(Dynamic Binding, Late Binding)

   Daca decizia legarii se ia run-time, atunci se va executa functia
   definita in clasa obiectului nou creat dinamic. Conteaza tipul pointerului, nu tipul obiectului creat dinamic
*/

int main()
{
    Fiinta* pf;

    pf = new Fiinta();
    pf->SeHraneste(); // -> Operator de Acces Indirect la membri clasei
    delete pf;


    pf = new Om();         // Legare statica
    pf->SeHraneste();
    delete pf;

    pf = new Animal();     // Legare statica
    pf->SeHraneste();
    delete pf;

    pf = new Caine();      // Legare statica
    pf->SeHraneste();
    delete pf;
}
