// Polimorfism
#include <iostream>
#include <vector>
using namespace std;
// Functii virtuale

class Fiinta {
public:
    virtual void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Om : public Fiinta {
public:
    void SeHraneste() const // Overriding
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Animal : public Fiinta {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

class Caine : public Animal {
public:
    void SeHraneste() const
    {
        cout << __PRETTY_FUNCTION__ << '\n';
    }
};

/* Spunem ca functia SeHraneste() are un comportament polimorfic
    Obiectele care contin functii virtuale se numesc POLIMORFICE
*/
int main()
{
    vector<Fiinta*> pf = { new Fiinta(), new Om(),
                     new Animal(), new Caine()
                   };

    for (int i = 0; i < 4; ++i)
        pf[i]->SeHraneste();
    cout << '\n';

    for (Fiinta* p : pf)
        p->SeHraneste();
}
